=== declarative/qml/CMakeLists.txt ===
set(phonon_QMLS
    qml/qmldir
    qml/VideoPlayer.qml
    PARENT_SCOPE
)
