=== debian/changelog ===
phonon (4:4.8.3-0ubuntu3) xenial; urgency=medium

  * Cherry-pick some changes from Debian, in the absence of a full merge.
    Brings improvements in compiler flag usage, which should fix FTBFS of
    reverse depends.
  * Add patches:
    + debian/patches/fix_include_dirs
    + debian/patches/upstream_dont_allocate_a_char_with_undefined_size
    + debian/patches/upstream_fix_build_with_qt_5.4.2
    + debian/patches/upstream_tear_cmake_logic_for_qt4_and_qt5_apart
  * Add build-dep on extra-cmake-modules.

 -- Iain Lane <iain@orangesquash.org.uk>  Fri, 13 Nov 2015 12:22:42 +0000

phonon (4:4.8.3-0ubuntu2) vivid; urgency=medium

  * Update symbols files for GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 10 Mar 2015 16:22:58 +0100

phonon (4:4.8.3-0ubuntu1) vivid; urgency=medium

  * New upstream release.

 -- Mikhail Ivchenko <ematirov@gmail.com>  Fri, 12 Dec 2014 15:24:43 +0000

phonon (4:4.8.2-0ubuntu1) vivid; urgency=medium

  * New upstream release. 

 -- Ron Betzen <rbetzen@frenchmerchants.net>  Mon, 24 Nov 2014 23:55:28 +0000

phonon (4:4.8.0-~4ubuntu2) vivid; urgency=medium

  * Remove phonon_is_not_forced_in_KDE.diff which installs header files
    to the wrong directory

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 07 Nov 2014 14:46:07 +0100

phonon (4:4.8.0-~4ubuntu1) vivid; urgency=medium

  * Merge with Debian, remaining changes:
    - Drop universe dependency libqzeitgeist-dev.
    - in debian/rules set default to gstreamer
    - move qt5 experimental headers from libphonon4qt5-dev.install
      to libphonon4qt5experimental-dev.install

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 29 Oct 2014 17:18:34 +0000

phonon (4:4.8.0-4) UNRELEASED; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Add myself to Uploaders.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Mon, 06 Oct 2014 14:03:01 -0300
