=== debian/watch ===
version=3

http://download.kde.org/stable/phonon/([\d.]+)/ phonon-([\d.]+).tar.xz
